﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Input;

namespace WpfApplication1
{
    public partial class App : Application
    {
        public App()
        {
            FocusManager.FocusedElementProperty.OverrideMetadata(
                typeof(Window1),
                new UIPropertyMetadata((sender, e) =>
                {
                    string name = "n/a";
                    string type = "n/a";
                    int hash = -1;

                    if (e.NewValue != null)
                    {
                        var depObj = e.NewValue as DependencyObject;
                        name = depObj.GetValue(FrameworkElement.NameProperty) as string;
                        type = depObj.GetType().FullName;
                        hash = depObj.GetHashCode();
                    }

                    string msg = String.Format(
                        "FOCUSED ELEMENT: Name='{0}' Type='{1}' HashCode='{2}'",
                        name, type, hash);

                    Debug.WriteLine(msg);
                }));
        }
    }
}